package com.cosmodas.EntCosmos;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;
import java.math.BigDecimal;

@Entity
@Table(name = "inventario_papeleria")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "InventarioPapeleria.findAll", query = "SELECT f FROM InventarioPapeleria f"),
        @NamedQuery(name = "InventarioPapeleria.findByCodigoPapeleria", query = "SELECT f FROM InventarioPapeleria f WHERE f.inventarioPapeleriaPK.codigoPapeleria = :codigoPapeleria"),
        @NamedQuery(name = "InventarioPapeleria.findByDepartamento", query = "SELECT f FROM InventarioPapeleria f WHERE f.inventarioPapeleriaPK.departamento = :departamento"),
        @NamedQuery(name = "InventarioPapeleria.findByExistenciaAnterior", query = "SELECT f FROM InventarioPapeleria f WHERE f.existenciaAnterior = :existenciaAnterior"),
        @NamedQuery(name = "InventarioPapeleria.findByExistenciaActual", query = "SELECT f FROM InventarioPapeleria f WHERE f.existenciaActual = :existenciaActual"),
        @NamedQuery(name = "InventarioPapeleria.findByExistenciaFisica", query = "SELECT f FROM InventarioPapeleria f WHERE f.existenciaFisica= :existenciaFisica")})

public class InventarioPapeleria implements Serializable {
    private static final long serialVersionUID = 1L;

    @EmbeddedId
    protected InventarioPapeleriaPK inventarioPapeleriaPK;

    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 3)
    @Column(name = "existencia_anterior")
    private Integer existenciaAnterior;

    @Column(name = "existencia_actual")
    private Integer existenciaActual;

    @Column(name = "existencia_fisica")
    private Integer existenciaFisica;

    public Integer getExistenciaAnterior() {
        return existenciaAnterior;
    }

    public void setExistenciaAnterior(Integer existenciaAnterior) {
        this.existenciaAnterior = existenciaAnterior;
    }

    public Integer getExistenciaActual() {
        return existenciaActual;
    }

    public void setExistenciaActual(Integer existenciaActual) {
        this.existenciaActual = existenciaActual;
    }

    public Integer getExistenciaFisica() {
        return existenciaFisica;
    }

    public void setExistenciaFisica(Integer existenciaFisica) {
        this.existenciaFisica = existenciaFisica;
    }

    public InventarioPapeleria(InventarioPapeleriaPK inventarioPapeleriaPK) {
        this.inventarioPapeleriaPK = inventarioPapeleriaPK;
    }

    public InventarioPapeleria(InventarioPapeleriaPK inventarioPapeleriaPK, Integer existenciaAnterior, Integer existenciaActual, Integer existenciaFisica){
      this.inventarioPapeleriaPK = inventarioPapeleriaPK;
        this.existenciaAnterior = existenciaAnterior;
        this.existenciaActual = existenciaActual;
        this.existenciaFisica = existenciaFisica;
    }

    public InventarioPapeleria(String codigoPapeleria, String departamento) {
        this.inventarioPapeleriaPK = new InventarioPapeleriaPK(codigoPapeleria, departamento);
    }

    public InventarioPapeleriaPK getInventarioPapeleriaPK() {
        return inventarioPapeleriaPK;
    }

    public void setInventarioPapeleriaPK(InventarioPapeleriaPK inventarioPapeleriaPK) {
        this.inventarioPapeleriaPK = inventarioPapeleriaPK;
    }

    public InventarioPapeleria(){

    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (inventarioPapeleriaPK != null ? inventarioPapeleriaPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof InventarioPapeleria)) {
            return false;
        }
        InventarioPapeleria other = (InventarioPapeleria) object;
        if ((this.inventarioPapeleriaPK == null && other.inventarioPapeleriaPK != null) || (this.inventarioPapeleriaPK != null && !this.inventarioPapeleriaPK.equals(other.inventarioPapeleriaPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.InventarioPapeleriaPK[ inventarioPapeleriaPK=" + inventarioPapeleriaPK + " ]";
    }
}
